
%{

#include <string.h>

#include "config.h"
#include "args-bison.h"

struct lt_args_include* lt_args_buf_get(void);

%}

alphnum		[-0-9a-zA-Z_]
name		({alphnum})+
filename	([-0-9a-zA-Z\./])+

%x comment include
%%

"/*"			BEGIN(comment);
<comment>[^*\n]*	/* eat anything that's not a '*' */
<comment>"*"+[^*/\n]*	/* eat up '*'s not followed by '/'s */
<comment>\n		{ lt_args_buf_get()->lineno++; }
<comment>"*"+"/"	{ lt_args_buf_get()->lineno++; } BEGIN(INITIAL);

"#include"		{ BEGIN(include); return INCLUDE; }
<include>{filename}	{ yylval.s = strdup(yytext); return FILENAME; } 
<include>"\""		{ return '"'; }
<include>\n		{ BEGIN(INITIAL); }
<include>.		{ ; }

<<EOF>>			{ return END; }
"struct"		{ return STRUCT; }
"typedef"		{ return TYPEDEF; }
{name}			{ yylval.s = strdup(yytext); return NAME; }   
"\*"			{ return '*'; }
")"			{ return ')'; }
"("			{ return '('; }
"}"			{ return '}'; }
"{"			{ return '{'; }
";"			{ return ';'; }
","			{ return ','; }
\			{ ; }
\n			{ lt_args_buf_get()->lineno++; }
.			{ ; }

%%

#ifndef yywrap
int yywrap()
{
	return 1; 
	/* XXX not to get the compiler 'not used' warning */
	yyunput(0, NULL); 
	input();
}
#endif

void yyerror(const char *m)
{
	printf("latrace config file [%s] line %d: %s\n", 
		lt_args_buf_get()->file, 
		lt_args_buf_get()->lineno++, 
		m); 
}
