
#include "config.h"

static char spaces[] = "                                                                                                                                                                           ";

static int print_details(struct lt_config_shared *cfg, char *argdbuf)
{
	fprintf(cfg->fout, "%s\n", argdbuf);
	return 0;
}

#define PRINT_TID() \
do { \
	fprintf(cfg->fout, "%5d   ", (pid_t) syscall(SYS_gettid)); \
} while(0)

int lt_out_entry(struct lt_config_shared *cfg, const char *symname, char *lib_to, 
			char *argbuf, char *argdbuf)
{
	PRINT_TID();

	if (cfg->indent_depth && cfg->indent_sym)
		fprintf(cfg->fout, "%.*s", cfg->indent_depth * cfg->indent_size, spaces);

	if (*argbuf)
		fprintf(cfg->fout, "%s(%s) [%s] {\n", symname, argbuf, lib_to);
	else
		fprintf(cfg->fout, "%s [%s]\n", symname, lib_to);

	if (cfg->args_detailed && *argdbuf)
		print_details(cfg, argdbuf);

	fflush(NULL);
	return 0;
}

int lt_out_exit(struct lt_config_shared *cfg, const char *symname, char *lib_to, 
			char *argbuf, char *argdbuf)
{
	if (!*argbuf)
		return 0;

	PRINT_TID();

	if (cfg->indent_depth && cfg->indent_sym)
		fprintf(cfg->fout, "%.*s", cfg->indent_depth * cfg->indent_size, spaces);

	fprintf(cfg->fout, "} %s%s\n", symname, argbuf);

	if (cfg->args_detailed && *argdbuf)
		print_details(cfg, argdbuf);
	
	fflush(NULL);
	return 0;
}
